Code

contrib/completion: "local var=()" is misinterpreted as func-decl by zsh
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
10 --
11 i,interactive   run interactively
12 b,binary*       (historical option -- no-op)
13 3,3way          allow fall back on 3way merging if needed
14 q,quiet         be quiet
15 s,signoff       add a Signed-off-by line to the commit message
16 u,utf8          recode into utf8 (default)
17 k,keep          pass -k flag to git-mailinfo
18 keep-non-patch  pass -b flag to git-mailinfo
19 keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
20 no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
21 c,scissors      strip everything before a scissors line
22 whitespace=     pass it through git-apply
23 ignore-space-change pass it through git-apply
24 ignore-whitespace pass it through git-apply
25 directory=      pass it through git-apply
26 exclude=        pass it through git-apply
27 C=              pass it through git-apply
28 p=              pass it through git-apply
29 patch-format=   format the patch(es) are in
30 reject          pass it through git-apply
31 resolvemsg=     override error message when patch failure occurs
32 continue        continue applying patches after resolving a conflict
33 r,resolved      synonyms for --continue
34 skip            skip the current patch
35 abort           restore the original branch and abort the patching operation.
36 committer-date-is-author-date    lie about committer date
37 ignore-date     use current timestamp for author date
38 rerere-autoupdate update the index with reused conflict resolution if possible
39 rebasing*       (internal use for git-rebase)"
41 . git-sh-setup
42 . git-sh-i18n
43 prefix=$(git rev-parse --show-prefix)
44 set_reflog_action am
45 require_work_tree
46 cd_to_toplevel
48 git var GIT_COMMITTER_IDENT >/dev/null ||
49         die "$(gettext "You need to set your committer info first")"
51 if git rev-parse --verify -q HEAD >/dev/null
52 then
53         HAS_HEAD=yes
54 else
55         HAS_HEAD=
56 fi
58 cmdline="git am"
59 if test '' != "$interactive"
60 then
61         cmdline="$cmdline -i"
62 fi
63 if test '' != "$threeway"
64 then
65         cmdline="$cmdline -3"
66 fi
68 sq () {
69         git rev-parse --sq-quote "$@"
70 }
72 stop_here () {
73     echo "$1" >"$dotest/next"
74     git rev-parse --verify -q HEAD >"$dotest/abort-safety"
75     exit 1
76 }
78 safe_to_abort () {
79         if test -f "$dotest/dirtyindex"
80         then
81                 return 1
82         fi
84         if ! test -s "$dotest/abort-safety"
85         then
86                 return 0
87         fi
89         abort_safety=$(cat "$dotest/abort-safety")
90         if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
91         then
92                 return 0
93         fi
94                 gettextln "You seem to have moved HEAD since the last 'am' failure.
95 Not rewinding to ORIG_HEAD" >&2
96         return 1
97 }
99 stop_here_user_resolve () {
100     if [ -n "$resolvemsg" ]; then
101             printf '%s\n' "$resolvemsg"
102             stop_here $1
103     fi
104     eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
105 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
106 To restore the original branch and stop patching run \"\$cmdline --abort\"."
108     stop_here $1
111 go_next () {
112         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
113                 "$dotest/patch" "$dotest/info"
114         echo "$next" >"$dotest/next"
115         this=$next
118 cannot_fallback () {
119         echo "$1"
120         gettextln "Cannot fall back to three-way merge."
121         exit 1
124 fall_back_3way () {
125     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
127     rm -fr "$dotest"/patch-merge-*
128     mkdir "$dotest/patch-merge-tmp-dir"
130     # First see if the patch records the index info that we can use.
131     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
132         "$dotest/patch" &&
133     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
134     git write-tree >"$dotest/patch-merge-base+" ||
135     cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
137     say Using index info to reconstruct a base tree...
138     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
139         git apply --cached <"$dotest/patch"
140     then
141         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
142         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
143     else
144         cannot_fallback "$(gettext "Did you hand edit your patch?
145 It does not apply to blobs recorded in its index.")"
146     fi
148     test -f "$dotest/patch-merge-index" &&
149     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
150     orig_tree=$(cat "$dotest/patch-merge-base") &&
151     rm -fr "$dotest"/patch-merge-* || exit 1
153     say "$(gettext "Falling back to patching base and 3-way merge...")"
155     # This is not so wrong.  Depending on which base we picked,
156     # orig_tree may be wildly different from ours, but his_tree
157     # has the same set of wildly different changes in parts the
158     # patch did not touch, so recursive ends up canceling them,
159     # saying that we reverted all those changes.
161     eval GITHEAD_$his_tree='"$FIRSTLINE"'
162     export GITHEAD_$his_tree
163     if test -n "$GIT_QUIET"
164     then
165             GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
166     fi
167     git-merge-recursive $orig_tree -- HEAD $his_tree || {
168             git rerere $allow_rerere_autoupdate
169             echo Failed to merge in the changes.
170             exit 1
171     }
172     unset GITHEAD_$his_tree
175 clean_abort () {
176         test $# = 0 || echo >&2 "$@"
177         rm -fr "$dotest"
178         exit 1
181 patch_format=
183 check_patch_format () {
184         # early return if patch_format was set from the command line
185         if test -n "$patch_format"
186         then
187                 return 0
188         fi
190         # we default to mbox format if input is from stdin and for
191         # directories
192         if test $# = 0 || test "x$1" = "x-" || test -d "$1"
193         then
194                 patch_format=mbox
195                 return 0
196         fi
198         # otherwise, check the first few non-blank lines of the first
199         # patch to try to detect its format
200         {
201                 # Start from first line containing non-whitespace
202                 l1=
203                 while test -z "$l1"
204                 do
205                         read l1
206                 done
207                 read l2
208                 read l3
209                 case "$l1" in
210                 "From "* | "From: "*)
211                         patch_format=mbox
212                         ;;
213                 '# This series applies on GIT commit'*)
214                         patch_format=stgit-series
215                         ;;
216                 "# HG changeset patch")
217                         patch_format=hg
218                         ;;
219                 *)
220                         # if the second line is empty and the third is
221                         # a From, Author or Date entry, this is very
222                         # likely an StGIT patch
223                         case "$l2,$l3" in
224                         ,"From: "* | ,"Author: "* | ,"Date: "*)
225                                 patch_format=stgit
226                                 ;;
227                         *)
228                                 ;;
229                         esac
230                         ;;
231                 esac
232                 if test -z "$patch_format" &&
233                         test -n "$l1" &&
234                         test -n "$l2" &&
235                         test -n "$l3"
236                 then
237                         # This begins with three non-empty lines.  Is this a
238                         # piece of e-mail a-la RFC2822?  Grab all the headers,
239                         # discarding the indented remainder of folded lines,
240                         # and see if it looks like that they all begin with the
241                         # header field names...
242                         tr -d '\015' <"$1" |
243                         sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
244                         sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
245                         patch_format=mbox
246                 fi
247         } < "$1" || clean_abort
250 split_patches () {
251         case "$patch_format" in
252         mbox)
253                 if test -n "$rebasing" || test t = "$keepcr"
254                 then
255                     keep_cr=--keep-cr
256                 else
257                     keep_cr=
258                 fi
259                 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
260                 clean_abort
261                 ;;
262         stgit-series)
263                 if test $# -ne 1
264                 then
265                         clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
266                 fi
267                 series_dir=`dirname "$1"`
268                 series_file="$1"
269                 shift
270                 {
271                         set x
272                         while read filename
273                         do
274                                 set "$@" "$series_dir/$filename"
275                         done
276                         # remove the safety x
277                         shift
278                         # remove the arg coming from the first-line comment
279                         shift
280                 } < "$series_file" || clean_abort
281                 # set the patch format appropriately
282                 patch_format=stgit
283                 # now handle the actual StGIT patches
284                 split_patches "$@"
285                 ;;
286         stgit)
287                 this=0
288                 for stgit in "$@"
289                 do
290                         this=`expr "$this" + 1`
291                         msgnum=`printf "%0${prec}d" $this`
292                         # Perl version of StGIT parse_patch. The first nonemptyline
293                         # not starting with Author, From or Date is the
294                         # subject, and the body starts with the next nonempty
295                         # line not starting with Author, From or Date
296                         perl -ne 'BEGIN { $subject = 0 }
297                                 if ($subject > 1) { print ; }
298                                 elsif (/^\s+$/) { next ; }
299                                 elsif (/^Author:/) { s/Author/From/ ; print ;}
300                                 elsif (/^(From|Date)/) { print ; }
301                                 elsif ($subject) {
302                                         $subject = 2 ;
303                                         print "\n" ;
304                                         print ;
305                                 } else {
306                                         print "Subject: ", $_ ;
307                                         $subject = 1;
308                                 }
309                         ' < "$stgit" > "$dotest/$msgnum" || clean_abort
310                 done
311                 echo "$this" > "$dotest/last"
312                 this=
313                 msgnum=
314                 ;;
315         hg)
316                 this=0
317                 for hg in "$@"
318                 do
319                         this=$(( $this + 1 ))
320                         msgnum=$(printf "%0${prec}d" $this)
321                         # hg stores changeset metadata in #-commented lines preceding
322                         # the commit message and diff(s). The only metadata we care about
323                         # are the User and Date (Node ID and Parent are hashes which are
324                         # only relevant to the hg repository and thus not useful to us)
325                         # Since we cannot guarantee that the commit message is in
326                         # git-friendly format, we put no Subject: line and just consume
327                         # all of the message as the body
328                         perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
329                                 if ($subject) { print ; }
330                                 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
331                                 elsif (/^\# Date /) {
332                                         my ($hashsign, $str, $time, $tz) = split ;
333                                         $tz = sprintf "%+05d", (0-$tz)/36;
334                                         print "Date: " .
335                                               strftime("%a, %d %b %Y %H:%M:%S ",
336                                                        localtime($time))
337                                               . "$tz\n";
338                                 } elsif (/^\# /) { next ; }
339                                 else {
340                                         print "\n", $_ ;
341                                         $subject = 1;
342                                 }
343                         ' <"$hg" >"$dotest/$msgnum" || clean_abort
344                 done
345                 echo "$this" >"$dotest/last"
346                 this=
347                 msgnum=
348                 ;;
349         *)
350                 if test -n "$patch_format"
351                 then
352                         clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
353                 else
354                         clean_abort "$(gettext "Patch format detection failed.")"
355                 fi
356                 ;;
357         esac
360 prec=4
361 dotest="$GIT_DIR/rebase-apply"
362 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
363 resolvemsg= resume= scissors= no_inbody_headers=
364 git_apply_opt=
365 committer_date_is_author_date=
366 ignore_date=
367 allow_rerere_autoupdate=
369 if test "$(git config --bool --get am.keepcr)" = true
370 then
371     keepcr=t
372 fi
374 while test $# != 0
375 do
376         case "$1" in
377         -i|--interactive)
378                 interactive=t ;;
379         -b|--binary)
380                 : ;;
381         -3|--3way)
382                 threeway=t ;;
383         -s|--signoff)
384                 sign=t ;;
385         -u|--utf8)
386                 utf8=t ;; # this is now default
387         --no-utf8)
388                 utf8= ;;
389         -k|--keep)
390                 keep=t ;;
391         --keep-non-patch)
392                 keep=b ;;
393         -c|--scissors)
394                 scissors=t ;;
395         --no-scissors)
396                 scissors=f ;;
397         -r|--resolved|--continue)
398                 resolved=t ;;
399         --skip)
400                 skip=t ;;
401         --abort)
402                 abort=t ;;
403         --rebasing)
404                 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
405         -d|--dotest)
406                 die "$(gettext "-d option is no longer supported.  Do not use.")"
407                 ;;
408         --resolvemsg)
409                 shift; resolvemsg=$1 ;;
410         --whitespace|--directory|--exclude)
411                 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
412         -C|-p)
413                 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
414         --patch-format)
415                 shift ; patch_format="$1" ;;
416         --reject|--ignore-whitespace|--ignore-space-change)
417                 git_apply_opt="$git_apply_opt $1" ;;
418         --committer-date-is-author-date)
419                 committer_date_is_author_date=t ;;
420         --ignore-date)
421                 ignore_date=t ;;
422         --rerere-autoupdate|--no-rerere-autoupdate)
423                 allow_rerere_autoupdate="$1" ;;
424         -q|--quiet)
425                 GIT_QUIET=t ;;
426         --keep-cr)
427                 keepcr=t ;;
428         --no-keep-cr)
429                 keepcr=f ;;
430         --)
431                 shift; break ;;
432         *)
433                 usage ;;
434         esac
435         shift
436 done
438 # If the dotest directory exists, but we have finished applying all the
439 # patches in them, clear it out.
440 if test -d "$dotest" &&
441    last=$(cat "$dotest/last") &&
442    next=$(cat "$dotest/next") &&
443    test $# != 0 &&
444    test "$next" -gt "$last"
445 then
446    rm -fr "$dotest"
447 fi
449 if test -d "$dotest"
450 then
451         case "$#,$skip$resolved$abort" in
452         0,*t*)
453                 # Explicit resume command and we do not have file, so
454                 # we are happy.
455                 : ;;
456         0,)
457                 # No file input but without resume parameters; catch
458                 # user error to feed us a patch from standard input
459                 # when there is already $dotest.  This is somewhat
460                 # unreliable -- stdin could be /dev/null for example
461                 # and the caller did not intend to feed us a patch but
462                 # wanted to continue unattended.
463                 test -t 0
464                 ;;
465         *)
466                 false
467                 ;;
468         esac ||
469         die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
470         resume=yes
472         case "$skip,$abort" in
473         t,t)
474                 die "$(gettext "Please make up your mind. --skip or --abort?")"
475                 ;;
476         t,)
477                 git rerere clear
478                 git read-tree --reset -u HEAD HEAD
479                 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
480                 git reset HEAD
481                 git update-ref ORIG_HEAD $orig_head
482                 ;;
483         ,t)
484                 if test -f "$dotest/rebasing"
485                 then
486                         exec git rebase --abort
487                 fi
488                 git rerere clear
489                 if safe_to_abort
490                 then
491                         git read-tree --reset -u HEAD ORIG_HEAD
492                         git reset ORIG_HEAD
493                 fi
494                 rm -fr "$dotest"
495                 exit ;;
496         esac
497         rm -f "$dotest/dirtyindex"
498 else
499         # Make sure we are not given --skip, --resolved, nor --abort
500         test "$skip$resolved$abort" = "" ||
501                 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
503         # Start afresh.
504         mkdir -p "$dotest" || exit
506         if test -n "$prefix" && test $# != 0
507         then
508                 first=t
509                 for arg
510                 do
511                         test -n "$first" && {
512                                 set x
513                                 first=
514                         }
515                         if is_absolute_path "$arg"
516                         then
517                                 set "$@" "$arg"
518                         else
519                                 set "$@" "$prefix$arg"
520                         fi
521                 done
522                 shift
523         fi
525         check_patch_format "$@"
527         split_patches "$@"
529         # -i can and must be given when resuming; everything
530         # else is kept
531         echo " $git_apply_opt" >"$dotest/apply-opt"
532         echo "$threeway" >"$dotest/threeway"
533         echo "$sign" >"$dotest/sign"
534         echo "$utf8" >"$dotest/utf8"
535         echo "$keep" >"$dotest/keep"
536         echo "$scissors" >"$dotest/scissors"
537         echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
538         echo "$GIT_QUIET" >"$dotest/quiet"
539         echo 1 >"$dotest/next"
540         if test -n "$rebasing"
541         then
542                 : >"$dotest/rebasing"
543         else
544                 : >"$dotest/applying"
545                 if test -n "$HAS_HEAD"
546                 then
547                         git update-ref ORIG_HEAD HEAD
548                 else
549                         git update-ref -d ORIG_HEAD >/dev/null 2>&1
550                 fi
551         fi
552 fi
554 git update-index -q --refresh
556 case "$resolved" in
557 '')
558         case "$HAS_HEAD" in
559         '')
560                 files=$(git ls-files) ;;
561         ?*)
562                 files=$(git diff-index --cached --name-only HEAD --) ;;
563         esac || exit
564         if test "$files"
565         then
566                 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
567                 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
568         fi
569 esac
571 # Now, decide what command line options we will give to the git
572 # commands we invoke, based on the result of parsing command line
573 # options and previous invocation state stored in $dotest/ files.
575 if test "$(cat "$dotest/utf8")" = t
576 then
577         utf8=-u
578 else
579         utf8=-n
580 fi
581 keep=$(cat "$dotest/keep")
582 case "$keep" in
583 t)
584         keep=-k ;;
585 b)
586         keep=-b ;;
587 *)
588         keep= ;;
589 esac
590 case "$(cat "$dotest/scissors")" in
591 t)
592         scissors=--scissors ;;
593 f)
594         scissors=--no-scissors ;;
595 esac
596 if test "$(cat "$dotest/no_inbody_headers")" = t
597 then
598         no_inbody_headers=--no-inbody-headers
599 else
600         no_inbody_headers=
601 fi
602 if test "$(cat "$dotest/quiet")" = t
603 then
604         GIT_QUIET=t
605 fi
606 if test "$(cat "$dotest/threeway")" = t
607 then
608         threeway=t
609 fi
610 git_apply_opt=$(cat "$dotest/apply-opt")
611 if test "$(cat "$dotest/sign")" = t
612 then
613         SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
614                         s/>.*/>/
615                         s/^/Signed-off-by: /'
616                 `
617 else
618         SIGNOFF=
619 fi
621 last=`cat "$dotest/last"`
622 this=`cat "$dotest/next"`
623 if test "$skip" = t
624 then
625         this=`expr "$this" + 1`
626         resume=
627 fi
629 while test "$this" -le "$last"
630 do
631         msgnum=`printf "%0${prec}d" $this`
632         next=`expr "$this" + 1`
633         test -f "$dotest/$msgnum" || {
634                 resume=
635                 go_next
636                 continue
637         }
639         # If we are not resuming, parse and extract the patch information
640         # into separate files:
641         #  - info records the authorship and title
642         #  - msg is the rest of commit log message
643         #  - patch is the patch body.
644         #
645         # When we are resuming, these files are either already prepared
646         # by the user, or the user can tell us to do so by --resolved flag.
647         case "$resume" in
648         '')
649                 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
650                         <"$dotest/$msgnum" >"$dotest/info" ||
651                         stop_here $this
653                 # skip pine's internal folder data
654                 sane_grep '^Author: Mail System Internal Data$' \
655                         <"$dotest"/info >/dev/null &&
656                         go_next && continue
658                 test -s "$dotest/patch" || {
659                         eval_gettextln "Patch is empty.  Was it split wrong?
660 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
661 To restore the original branch and stop patching run \"\$cmdline --abort\"."
662                         stop_here $this
663                 }
664                 rm -f "$dotest/original-commit" "$dotest/author-script"
665                 if test -f "$dotest/rebasing" &&
666                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
667                                 -e q "$dotest/$msgnum") &&
668                         test "$(git cat-file -t "$commit")" = commit
669                 then
670                         git cat-file commit "$commit" |
671                         sed -e '1,/^$/d' >"$dotest/msg-clean"
672                         echo "$commit" > "$dotest/original-commit"
673                         get_author_ident_from_commit "$commit" > "$dotest/author-script"
674                 else
675                         {
676                                 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
677                                 echo
678                                 cat "$dotest/msg"
679                         } |
680                         git stripspace > "$dotest/msg-clean"
681                 fi
682                 ;;
683         esac
685         if test -f "$dotest/author-script"
686         then
687                 eval $(cat "$dotest/author-script")
688         else
689                 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
690                 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
691                 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
692         fi
694         if test -z "$GIT_AUTHOR_EMAIL"
695         then
696                 gettextln "Patch does not have a valid e-mail address."
697                 stop_here $this
698         fi
700         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
702         case "$resume" in
703         '')
704             if test '' != "$SIGNOFF"
705             then
706                 LAST_SIGNED_OFF_BY=`
707                     sed -ne '/^Signed-off-by: /p' \
708                     "$dotest/msg-clean" |
709                     sed -ne '$p'
710                 `
711                 ADD_SIGNOFF=`
712                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
713                     test '' = "$LAST_SIGNED_OFF_BY" && echo
714                     echo "$SIGNOFF"
715                 }`
716             else
717                 ADD_SIGNOFF=
718             fi
719             {
720                 if test -s "$dotest/msg-clean"
721                 then
722                         cat "$dotest/msg-clean"
723                 fi
724                 if test '' != "$ADD_SIGNOFF"
725                 then
726                         echo "$ADD_SIGNOFF"
727                 fi
728             } >"$dotest/final-commit"
729             ;;
730         *)
731                 case "$resolved$interactive" in
732                 tt)
733                         # This is used only for interactive view option.
734                         git diff-index -p --cached HEAD -- >"$dotest/patch"
735                         ;;
736                 esac
737         esac
739         resume=
740         if test "$interactive" = t
741         then
742             test -t 0 ||
743             die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
744             action=again
745             while test "$action" = again
746             do
747                 gettextln "Commit Body is:"
748                 echo "--------------------------"
749                 cat "$dotest/final-commit"
750                 echo "--------------------------"
751                 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
752                 # in your translation. The program will only accept English
753                 # input at this point.
754                 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
755                 read reply
756                 case "$reply" in
757                 [yY]*) action=yes ;;
758                 [aA]*) action=yes interactive= ;;
759                 [nN]*) action=skip ;;
760                 [eE]*) git_editor "$dotest/final-commit"
761                        action=again ;;
762                 [vV]*) action=again
763                        git_pager "$dotest/patch" ;;
764                 *)     action=again ;;
765                 esac
766             done
767         else
768             action=yes
769         fi
771         if test -f "$dotest/final-commit"
772         then
773                 FIRSTLINE=$(sed 1q "$dotest/final-commit")
774         else
775                 FIRSTLINE=""
776         fi
778         if test $action = skip
779         then
780                 go_next
781                 continue
782         fi
784         if test -x "$GIT_DIR"/hooks/applypatch-msg
785         then
786                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
787                 stop_here $this
788         fi
790         say "$(eval_gettext "Applying: \$FIRSTLINE")"
792         case "$resolved" in
793         '')
794                 # When we are allowed to fall back to 3-way later, don't give
795                 # false errors during the initial attempt.
796                 squelch=
797                 if test "$threeway" = t
798                 then
799                         squelch='>/dev/null 2>&1 '
800                 fi
801                 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
802                 apply_status=$?
803                 ;;
804         t)
805                 # Resolved means the user did all the hard work, and
806                 # we do not have to do any patch application.  Just
807                 # trust what the user has in the index file and the
808                 # working tree.
809                 resolved=
810                 git diff-index --quiet --cached HEAD -- && {
811                         gettextln "No changes - did you forget to use 'git add'?
812 If there is nothing left to stage, chances are that something else
813 already introduced the same changes; you might want to skip this patch."
814                         stop_here_user_resolve $this
815                 }
816                 unmerged=$(git ls-files -u)
817                 if test -n "$unmerged"
818                 then
819                         gettextln "You still have unmerged paths in your index
820 did you forget to use 'git add'?"
821                         stop_here_user_resolve $this
822                 fi
823                 apply_status=0
824                 git rerere
825                 ;;
826         esac
828         if test $apply_status != 0 && test "$threeway" = t
829         then
830                 if (fall_back_3way)
831                 then
832                     # Applying the patch to an earlier tree and merging the
833                     # result may have produced the same tree as ours.
834                     git diff-index --quiet --cached HEAD -- && {
835                         say "$(gettext "No changes -- Patch already applied.")"
836                         go_next
837                         continue
838                     }
839                     # clear apply_status -- we have successfully merged.
840                     apply_status=0
841                 fi
842         fi
843         if test $apply_status != 0
844         then
845                 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
846                 stop_here_user_resolve $this
847         fi
849         if test -x "$GIT_DIR"/hooks/pre-applypatch
850         then
851                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
852         fi
854         tree=$(git write-tree) &&
855         commit=$(
856                 if test -n "$ignore_date"
857                 then
858                         GIT_AUTHOR_DATE=
859                 fi
860                 parent=$(git rev-parse --verify -q HEAD) ||
861                 say >&2 "$(gettext "applying to an empty history")"
863                 if test -n "$committer_date_is_author_date"
864                 then
865                         GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
866                         export GIT_COMMITTER_DATE
867                 fi &&
868                 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
869         ) &&
870         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
871         stop_here $this
873         if test -f "$dotest/original-commit"; then
874                 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
875         fi
877         if test -x "$GIT_DIR"/hooks/post-applypatch
878         then
879                 "$GIT_DIR"/hooks/post-applypatch
880         fi
882         go_next
883 done
885 if test -s "$dotest"/rewritten; then
886     git notes copy --for-rewrite=rebase < "$dotest"/rewritten
887     if test -x "$GIT_DIR"/hooks/post-rewrite; then
888         "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
889     fi
890 fi
892 rm -fr "$dotest"
893 git gc --auto